10 REM ANTIBODY/ANTIGEN CONCENTRATION PROGRAM WRITTEN ON 05/09/1991
11 REM COMPUTER CENTER, INSTITUTE OF MICROBIAL TECHNOLOGY, CHANDIGARH
12 REM INDIA. 
20 CLS
30 DIM M[96],T[8]
40 DIM ST[96],STR[96],MC[96],MC1[96],MCR[96],MCR1[96]
50 DIM OD(8,12),OD1(8,12)
60 ON ERROR GOTO  3840
100 PRINT"**************************************************************"
110 PRINT"*               Ab/Ag Computer Program                       *"
120 PRINT"*                                                            *"
130 PRINT"**************************************************************"
140 PRINT"* This Program may Receive O.D. data directly from microtiter  *"
150 PRINT"* plate, from keyboard or from data file. The main function  *"
160 PRINT"* of this program is as below.                               *"
170 PRINT"*                                                            *"
180 PRINT"* 1. Print the data in 8 x 12 format                         *"
190 PRINT"* 2. Print the average data if samples are in dupl.,trip. etc*"
200 PRINT"* 3. Calculates the Semilogarithmic Linear Range of Ab/Ag    *"
210 PRINT"* 4. Derived the Linear Interpolation Formula                *"
220 PRINT"* 5. Derived the Hyperbolic Interpolation Formula            *"
230 PRINT"* 6. Calculates the Capacity, Flatness and Signal, which are *"
240 PRINT"*     the essential parameter for ELISA Optimization         *"
250 PRINT"* 7. Calculates the Ab/Ag concentration of unknown samples   *"
260 PRINT"**************************************************************" 
270 PRINT : INPUT "PLATE NO.:",PL
280 OPEN "SCRN:" FOR OUTPUT AS #1
290 P = 1
300 REM OPTIONS FOR USER TO FEED O.D. DATA DIRECTLY FROM 
310 REM PLATE READER OR BY USING FILE OR KEYBOARD 
320 PRINT :INPUT "INPUT O.D. DATA BY DIRECT/FILE/KEYBOARD (D/F/K):",C$
330 IF (C$ ="K" OR C$="k") THEN 370
340 IF(C$ = "F" OR C$ = "f") THEN GOTO 450
350 IF(C$ = "D" OR C$ = "d") THEN GOTO 550
360 BEEP :PRINT "NOT VALID CHOICE" :GOTO 320
370 FOR I = 1 TO 8
380 print"ENTER O.D. OF ROW NO. :"; :PRINT USING "###";I
390 FOR J = 1 TO 12
400 PRINT"COLUMN NO. ",J;
410 INPUT " :",OD(I,J)
420 NEXT J
430 NEXT I
440 GOTO 730
450 REM INPUT DATA FROM FILE
460 PRINT :INPUT "ENTER THE NAME OF THE O.D. DATA FILE :",FIL$
470 OPEN "I",#3,FIL$
480 FOR I = 1 TO 8
490 FOR J = 1 TO 12
500 INPUT#3,OD[I,J]
510 NEXT J
520 NEXT I
530 CLOSE #3
540 GOTO 730
550 REM INPUT O.D. DATA FROM SERIAL PORT
560 PRINT :INPUT "ENTER READER SLOT NUMBER:",FI$
570 RN = VAL (FI$)
580 IF (RN < 10) OR (RN > 1) THEN FIL$ = "CON" + FI$ + ":" ELSE FIL$ = "CON1:" 
590 OPEN "I",#3,FIL$
600 PRINT "SWITCH PLATE MOVEMENT TO AUTO AND HIT RUN WHEN READY TO BEGIN."
610 PRINT "PLEASE ALLOW READER TO FINISH PLATE"
620 PRINT : PRINT " READING PLATE "
630 FOR I = 1 TO 8
640 FOR J = 1 TO 12
650 INPUT#3,DEN$
660 IF LEFT$(DEN$,3) = "A 1" THEN PA$ = 1
670 IF PA$ < > "1" THEN GOTO 650
680 IF RIGHT$(DEN$,4) = "OVER" THEN DEN$ = 1.7
690 IF RIGHT$(DEN$,5) = "UNDER" THEN DEN$ = ".01"
700 OD[I,J] = VAL (RIGHT$(DEN$,6))
710 NEXT J
720 NEXT I
730 PRINT :INPUT "ENTER PRINTER PORT NUMBER:",FI$
740 RN = VAL (FI$)
750 IF (RN < 10) OR (RN > 1) THEN FIL$ = "LPT" + FI$ + ":" ELSE FIL$ = "LPT1:" 
760 OPEN "O",#2,FIL$
770 FOR I = 1 TO 8
780 FOR J = 1 TO 12
790 IF (OD[I,J] < .01) THEN OD[I,J] = .01
800 NEXT J: NEXT I
810 PRINT #P," "
820 PRINT #P,"               OPTICAL DENSITY IN 8 x 12 FORMAT"
830 PRINT #P, " " :PRINT #P,"  ";
840 FOR I = 1 TO 12
850 PRINT #P,USING "##";I;:PRINT #P,"    ";
860 NEXT I
870 FOR R = 1 TO 8
880 PRINT #P,:PRINT #P,CHR$(64+R); :PRINT #P," ";
890 FOR C = 1 TO 12
900 PRINT #P,USING "#.###";OD[R,C]; : PRINT #P," ";
910 NEXT C
920 NEXT R
930 PRINT #P," " :PRINT #P," "
940 IF P = 2 THEN GOTO 1300
950 PRINT :INPUT "DO YOU WANT TO EDIT THIS O.D. DATA (Y/N):" ,C$
960 IF(C$="Y" OR C$="y") OR (C$="N" OR C$="n") THEN 980
970 GOTO 950
980 IF(C$ = "N" OR C$ = "n") THEN GOTO 1100
990 REM TO EDIT THE O.D. DATA
1000 PRINT :INPUT "ENTER TOTAL NO. OF O.D. DATA TO BE MODIFY :",T1
1010 FOR K = 1 TO T1
1020 INPUT "ENTER ROW NO.    :",I
1030 INPUT "ENTER COLUMN NO. :",J
1040 PRINT "THE OLD VALUE OF ROW NO."; :PRINT USING "###";I;
1050 PRINT " AND COLUMN NO. "; :PRINT USING "###" ;J; : PRINT " IS ";
1060 PRINT USING "#.###";OD[I,J]
1070 INPUT "ENTER THE NEW VALUE :",OD[I,J]
1080 NEXT K
1090 GOTO 770
1100 PRINT :INPUT "DO YOU WANT TO STORE THIS DATA FOR FUTURE USE (Y/N):",C$
1110 IF(C$="Y" OR C$="y") OR (C$="N" OR C$="n") THEN 1130
1120 BEEP :GOTO 1100
1130 IF(C$ = "N" OR C$ = "n") THEN GOTO 1240
1140 REM PRINT THE O.D. DATA ON PRINTER
1150 PRINT :INPUT "ENTER THE NAME OF THE FILE :",FIL$
1160 OPEN "O",#3,FIL$
1170 REM STORE OD DATA IN 8x12 FORMAT IN THE FILE
1180 FOR R = 1 TO 8
1190 FOR C = 1 TO 12
1200 PRINT #3,OD[R,C];
1210 NEXT C
1220 PRINT #3,
1230 NEXT R
1240 PRINT :INPUT "DO YOU WANT TO PRINT THIS OD DATA ON PRINTER (Y/N):",C$
1250 IF(C$="Y" OR C$="y") OR (C$="N" OR C$="n") THEN 1270
1260 BEEP :GOTO 1240
1270 IF(C$ = "N" OR C$ = "n") THEN GOTO 1320
1280 P = 2
1290 GOTO 770
1300 REM FOR FEEDING DILUTION TEMPLATE DATA WHICH IS THE INFORMATION 
1310 REM ABOUT KNOWN STANDARDS
1320 BEEP :PRINT :PRINT
1330 INPUT "FEED DILUTION TEMPLATE DATA FROM KEYBOARD/FILE (K/F):",C$
1340 IF (C$ ="K" OR C$="k") THEN GOTO 1470
1350 IF(C$ = "F" OR C$ = "f") THEN GOTO 1370
1360 GOTO 1320
1370 PRINT :INPUT "ENTER NAME OF THE FILE (DILUTION TEMPLATE):",FIL$
1380 OPEN "I",#3,FIL$
1390 INPUT #3,SF,DF,TOT,IC1,U$
1400 FOR I = 1 TO TOT
1410 INPUT #3, T(I)
1420 NEXT I
1430 FOR I = 1 TO IC1
1440 INPUT #3, MC[I]
1450 NEXT I
1460 GOTO 2010
1470 PRINT 
1480 INPUT "ENTER TOTAL NO. OF ROWS USED FOR KNOWN STANDARDS (1-8):",TOT
1490 IF (TOT < 1) OR (TOT > 8) THEN BEEP :GOTO 1470
1500 PRINT
1510 INPUT "ENTER FIRST ROW NO. CONTAINING KNOWN STANDARDS (1-8):",T(1)
1520 IF (T(1) < 1) OR (T(1) > 8) THEN BEEP :GOTO 1500
1530 IF TOT < 2 THEN GOTO 1590
1540 FOR I = 2 TO TOT
1550 PRINT
1560 INPUT "ENTER NEXT ROW NO. CONTAINING KNOWN STANDARDS (1-8):",T(I)
1570 IF (T(I) < 1) OR (T(I) > 8) THEN BEEP :GOTO 1550
1580 NEXT I
1590 PRINT
1600 PRINT"ENTER WHETHER KNOWN STANDARDS ARE IN SINGLE,DUPLICATE OR "
1610 INPUT "TRIPLICATE. ENTER '1' FOR SINGLE '2' FOR DUPLICATE ETC. :",SF
1620 IF (SF < 1) OR (SF > 4) THEN BEEP :GOTO 1590
1630 IC1 = (TOT * 12)/SF :PRINT  
1640 INPUT "WHETHER THE CONC. OF KNOWN STd. ARE IN  LOG DILUTION (Y/N):",C$
1650 IF(C$="Y" OR C$="y") OR (C$="N" OR C$="n") THEN GOTO 1670
1660 BEEP :GOTO 1640
1670 IF(C$ = "N" OR C$ = "n") THEN GOTO 1780 
1680 PRINT 
1690 PRINT "ENTER DILUTION FACTOR OF KNOWN STD (2-5)" 
1700 INPUT "FOR EX. ENTER '2' FOR TWO-FOLD DILUTION:",DF
1710 IF (DF < 0) OR (DF > 5) THEN BEEP :GOTO 1680
1720 PRINT 
1730 INPUT "ENTER  INITIAL CONC. OF KNOWN STANDARD :",CONC
1740 FOR I = 1 TO IC1
1750 MC[I] = CONC /(DF^(I - 1))
1760 NEXT I
1770 GOTO 1820
1780 FOR I = 1 TO IC1 :PRINT
1790 INPUT "PLEASE ENTER THE CONC. OF KNOWN STANDARDS SERIALLY :",M
1800 MC(I) = M
1810 NEXT I
1820 PRINT :PRINT "THE Ab/Ag CONCENTRATION OF KNOWN STANDARDS ARE IN"
1830 INPUT "MICROGRAMS/ML (M) OR NANOGRAM/ML (N) OR PICOGRAM/ML (P):",C$
1840 IF (C$ ="M") OR (C$ = "m") THEN U$ ="MICROGRAMS/ML" :GOTO 1880
1850 IF (C$ ="N") OR (C$ = "n") THEN U$ ="NANOGRAM/ML"  :GOTO 1880
1860 IF (C$ ="P") OR (C$ = "p") THEN U$ ="PICOGRAM/ML"  :GOTO 1880
1870 BEEP : GOTO 1820
1880 INPUT "STORE DILUTION TEMPLaTe FOR FUTURE USE (Y/N):",C$
1890 IF (C$ = "N") OR (C$ = "n") THEN GOTO 1960
1900 IF (C$ = "Y") OR (C$ = "y") THEN GOTO 1920
1910 BEEP :GOTO 1880
1920 INPUT "ENTER NAME OF THE FILE:",FIL$
1930 OPEN "O",#3,FIL$
1940 PRINT #3,SF,DF,TOT,IC1,U$
1950 FOR I = 1 TO TOT
1960 PRINT #3,T(I)
1970 NEXT I
1980 FOR I = 1 TO IC1
1990 PRINT #3,MC[I]
2000 NEXT I
2010 REM TO PRINT THE AVERAGE DATA
2020 IF (P = 1) THEN GOTO 2060
2030 PRINT #P,"PLATE NO.:"; : PRINT #P,USING "###";PL
2040 PRINT #P,"DILUTION FACTOR:"; :PRINT #P, USING "###";DF :PRINT #P," "
2050 P = 1
2060 N = INT(12/SF)
2070 FOR I = 1 TO 8
2080 M = 0
2090 FOR J = 1 TO 12 STEP SF
2100 SUM = 0
2110 FOR K = J TO (J + SF - 1)
2120 SUM = SUM + OD(I,K)
2130 NEXT K
2140 M = M + 1
2150 SUM = SUM/SF
2160 OD1(I,M) = SUM
2170 NEXT J
2180 NEXT I
2190 PRINT
2200 IF SF = 1 THEN GOTO 2420
2210 PRINT #P,"        AVERAGE OD IN 8 X";:PRINT #P,USING "##";N;
2220 PRINT #P," FORMAT"
2230 PRINT #P,: PRINT #P,"  ";
2240 FOR I = 1 TO N
2250 PRINT #P,USING "##";I;:PRINT #P,"    ";
2260 NEXT I
2270 FOR R = 1 TO 8
2280 PRINT #P,:PRINT #P,CHR$(64+R); :PRINT #P," ";
2290 FOR C = 1 TO N
2300 PRINT #P,USING "#.###";OD1[R,C]; :PRINT #P," ";
2310 NEXT C
2320 NEXT R
2330 PRINT #P," " :PRINT #P," "
2340 IF P = 2 THEN GOTO 2410
2350 INPUT "DO YOU WANT TO PRINT THE AVERAGE O.D. DATA ON PRINTER :",C$
2360 IF(C$="Y" OR C$="y") OR (C$="N" OR C$="n") THEN 2380
2370 GOTO 2350
2380 IF(C$ = "N" OR C$ = "n") THEN GOTO 2420
2390 P = 2
2400 GOTO 2210
2410 P = 1
2420 REM TO SORT THE STD. DATA IN ORDER OF INCREASING CONCENTRATION
2430 K = 0
2440 FOR R = 1 TO TOT
2450 FOR C = 1 TO N
2460 I = T(R) : K = K + 1
2470 ST[K] = OD1[I,C]
2480 NEXT C
2490 NEXT R
2500 REM STANDARD DATA
2510 FOR I = 1 TO IC1
2520 CMIN = MC(I): CM = I
2530 FOR J = I+1 TO IC1
2540 IF MC(J) < CMIN THEN CMIN = MC(J) : CM = J
2550 NEXT J
2560 IF CM = I THEN GOTO 2620
2570 MC(CM) = MC(I)
2580 MC(I) = CMIN
2590 CMIN = ST(CM)
2600 ST(CM) = ST(I)
2610 ST[I] = CMIN
2620 NEXT I
2630 GOSUB 3550
2640 FOR R = 1 TO IC1
2650 MC1[R] = LOG(MC[R])/LOG(10)
2660 NEXT R
2670 K = 0
2680 PRINT #P,:PRINT #P,: PRINT #P,
2690 FOR C = 1 TO (IC1-1)
2700 M(C) = (ST(C+1) - ST(C))/(MC1(C+1) - MC1(C))
2710 IF M(C) > K THEN K = M(C) :J = C
2720 NEXT C
2730 I1 = 0 
2740 FOR C = 1 TO (IC1 - 1)
2750 IF M(C) < M(J)*.7 THEN IF C < J THEN GOTO 2810
2760 I1 = I1 + 1
2770 STR(I1) = ST(C)
2780 MCR(I1) = MC1(C)
2790 MCR1(I1) = MC(C)
2800 IF M(C) < M(J)*.7 THEN IF C > J THEN GOTO 2820
2810 NEXT C
2820 SMIN = STR(1) : SMAX = STR(I1)
2830 CMIN = MCR1(1) : CMAX = MCR1(I1)
2840 REM INTERPOLATION FORMULA DERIVATION
2850 GOSUB 3340
2860 PRINT #P," "
2870 PRINT #P,"THE Ab/Ag SL-RANGE(OD) : ";
2880 PRINT #P,USING "##.##";SMIN; : PRINT #P," - ";
2890 PRINT #P,USING "##.##";SMAX :PRINT #P," "
2900 PRINT #P,"LINEAR INTERPOLATION FORMULA: C = 10^(SL*OD + B)"
2910 PRINT #P,"WHERE SLOPE (SL) = "; : PRINT #P,USING "###.###";SL
2920 PRINT #P,"AND CONSTANT (B) = "; : PRINT #P,USING "###.###";B 
2930 PRINT #P," "
2940 PRINT #P,"HYPERBOLIC INTERPOLATION FORMULA: C = C0/(OD - Y0)  + X0"
2950 PRINT #P,"WHERE CAPACITY (X0) ="; : PRINT #P,USING "###.###";X0 
2960 PRINT #P,"SIGNAL (Y0) ="; : PRINT #P,USING "###.###";Y0
2970 PRINT #P,"AND FLATNESS (C0) ="; : PRINT #P,USING "###.###";C0
2980 REM TO DETERMINE THE CONCENTRATION OF UNKNOWN SAMPLES
2990 PRINT #P," "
3000 PRINT #P,"       ANTIBODY CONCENTRATION  IN "; :PRINT #P,U$
3010 FOR R = 1 TO 8
3020 PRINT #P,:PRINT #P,CHR$(64+R);
3030 FOR I = 1 TO TOT
3040 IF (T(I) = R) THEN GOTO 3170
3050 NEXT I
3060 FOR C = 1 TO N
3070 IF (OD1(R,C) < SMIN) THEN GOTO 3110
3080 IF (OD1(R,C) > SMAX) THEN GOTO 3110
3090 CONC = 10^(SL * OD1(R,C) + B)
3100 GOTO 3120
3110 CONC = (C0/(OD1(R,C) - Y0)) + X0
3120 PRINT #P,USING "###.##";CONC; :PRINT #P," ";
3130 GOTO 3150
3140 PRINT #P,"  OUT  ";
3150 NEXT C
3160 GOTO 3180
3170 PRINT #P,"              STANDARD SAMPLE ROW              ";
3180 NEXT R
3190 PRINT #P," " :PRINT #P," "
3200 IF P = 2 THEN GOTO 3280
3210 INPUT "DO YOU WANT TO PRINT ABOVE RESULTS ON PRINTER (Y/N)",C$
3220 IF(C$="Y" OR C$="y") OR (C$="N" OR C$="n") THEN 3240
3230 GOTO 3210
3240 IF(C$ = "N" OR C$ = "n") THEN GOTO 3280
3250 P = 2
3260 GOTO 2860
3270 P = 1
3280 PRINT :INPUT "DO YOU WANT TO RUN ANOTHER PLATE OR QUIT (R/Q):",C$
3290 IF(C$="R" OR C$="r") OR (C$="q" OR C$="Q") THEN 3310
3300 BEEP :PRINT :GOTO 3280
3310 IF(C$ = "R" OR C$ = "r") THEN CLOSE : CLS :GOTO 270
3320 PRINT "THANKS FOR USING Ab/Ag COMPUTER PROGRAM"
3330 END
3340 REM SUBROUTINE FOR DRIVING LINEAR INTERPOLATION FORMULA USING
3350 REM LINEAR REGRESSION AND LEAST SQUARE CURVE-FITTING METHOD
3360 SUMX = 0
3370 SUMY = 0
3380 SUMXY = 0
3390 SUMXSQ = 0
3400 FOR I = 1 TO I1
3410 SUMX = SUMX + MCR(I)
3420 SUMXSQ = SUMXSQ + MCR(I)^2
3430 SUMY = SUMY + STR(I)
3440 SUMXY = SUMXY + MCR(I) * STR(I)
3450 NEXT I
3460 DE = (I1*SUMXSQ) - (SUMX * SUMX)
3470 A0 = ((SUMY*SUMXSQ) - (SUMX*SUMXY))/DE
3480 A1 = ((I1*SUMXY) - (SUMX*SUMY))/DE
3490 REM FORMULA DERIVATION SUBROUTINE
3500 A0 = -(A0/A1)
3510 A1 = 1/A1
3520 SL = A1
3530 B = A0
3540 RETURN
3550 REM SUBROUTINE FOR DRIVING HYPERBOLIC INTERPOLATION FORMULA
3560 REM USING HYPERBOLIC REGRESSION METHOD
3570 REM 
3580 HSX = 0
3590 HSXX = 0
3600 HSY = 0
3610 HSYY = 0
3620 HSXY = 0
3630 HSXXY = 0
3640 HSXYY = 0
3650 FOR I = 1 TO IC1
3660 HSX = HSX + MC(I)
3670 HSXX = HSXX + MC(I) ^2
3680 HSY = HSY + ST(I)
3690 HSYY = HSYY + ST(I) ^2
3700 HSXY = HSXY + MC(I) * ST(I)
3710 HSXXY = HSXXY + (MC(I) ^2) * ST(I)
3720 HSXYY = HSXYY + MC(I) * (ST(I) ^2)
3730 NEXT I
3740 HSE = IC1 * HSXXY - HSXY * HSX
3750 HSF = IC1 * HSXYY - HSXY * HSY
3760 HSB = IC1 * HSXX - HSX * HSX
3770 HSC = IC1 * HSYY - HSY * HSY
3780 HSA = IC1 * HSXY - HSX * HSY
3790 HSD = HSA
3800 X0 = ((HSE * HSD) - (HSF * HSB))/((HSA * HSD) - (HSC * HSB))
3810 Y0 = ((HSA * HSF) - (HSC * HSE))/((HSA * HSD) - (HSC * HSB))
3820 C0 = ((HSXY - (X0 * HSY) - (Y0 * HSX))/IC1) + X0*Y0
3830 RETURN
3840 REM ERROR TRAPPING SUBROUTINE
3850 IF ERR=53 THEN PRINT "ENTER VALID FILE NAME" :FILES "*.*"
3860 IF (ERL < 550) THEN RESUME 300
3870 IF (ERL < 730) THEN RESUME 550
3880 IF (ERL < 770) THEN RESUME 730
3890 IF (ERL < 1300) THEN RESUME 770
3900 IF (ERL < 1880) THEN RESUME 1320
3910 PRINT "THERE IS SOME CALCULATION ERROR "
3920 GOTO 3280
3930 RETURN
